package org.rfdump;

/*
	RF Dump Frame
 */

import java.awt.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;
import java.util.Iterator;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JTable;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.table.TableModel;

public class RFIDFrame extends Frame
{
    public boolean scan = false;

    public RFID rfid = null;

    public HashMap writeBuffer = new HashMap();

	public RFIDFrame()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setSize(712,507);
		setVisible(false);
		label_tagType.setText("Tag Type:");
		add(label_tagType);
		label_tagType.setForeground(java.awt.Color.black);
		label_tagType.setFont(new Font("Dialog", Font.PLAIN, 12));
		label_tagType.setBounds(24,12,72,24);
		label_tagID.setText("Tag ID:");
		add(label_tagID);
		label_tagID.setForeground(java.awt.Color.black);
		label_tagID.setFont(new Font("Dialog", Font.PLAIN, 12));
		label_tagID.setBounds(24,48,60,24);
		tf_tagType.setEditable(false);
		add(tf_tagType);
		tf_tagType.setBounds(108,12,336,24);
		tf_tagID.setEditable(false);
		add(tf_tagID);
		tf_tagID.setBounds(108,48,336,24);
		label_memory.setText("Memory:");
		add(label_memory);
		label_memory.setForeground(java.awt.Color.black);
		label_memory.setFont(new Font("Dialog", Font.PLAIN, 12));
		label_memory.setBounds(24,84,72,24);
		bt_start.setText("START");
		bt_start.setActionCommand("START");
		add(bt_start);
		bt_start.setBounds(600,12,84,24);
		JScrollPane1.setOpaque(true);
		add(JScrollPane1);
		JScrollPane1.setBounds(24,120,660,360);
		JScrollPane1.getViewport().add(table_memory);
		table_memory.setBounds(0,0,657,0);
		setTitle("RF Dump - www.rfdump.org");
		setResizable(false);
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		bt_start.addActionListener(lSymAction);
		//}}
	}

	public RFIDFrame(String title)
	{
		this();
		setTitle(title);
	}

	static public void main(String args[])
	{
		(new RFIDFrame()).setVisible(true);
	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JLabel label_tagType = new javax.swing.JLabel();
	javax.swing.JLabel label_tagID = new javax.swing.JLabel();
	javax.swing.JTextField tf_tagType = new javax.swing.JTextField();
	javax.swing.JTextField tf_tagID = new javax.swing.JTextField();
	javax.swing.JLabel label_memory = new javax.swing.JLabel();
	javax.swing.JButton bt_start = new javax.swing.JButton();
	javax.swing.JScrollPane JScrollPane1 = new javax.swing.JScrollPane();
	javax.swing.JTable table_memory = new javax.swing.JTable();
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == RFIDFrame.this)
				RFIDFrame_WindowClosing(event);
		}
	}

	void RFIDFrame_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
        if (scan) scan = false;
        rfid.close();
        System.exit(0);
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == bt_start)
				btStart_actionPerformed(event);
		}
	}

    private void writePendingPages() {

        Set adrs = writeBuffer.keySet();
        Iterator iterator = adrs.iterator();

        while (iterator.hasNext()) {

            String adr = (String)iterator.next();
            String value = (String)writeBuffer.remove(adr);
            System.out.println("WRITING 0x" + adr + ": " + value);
            rfid.writePage(adr, value);
        }
    }

	void btStart_actionPerformed(java.awt.event.ActionEvent event)
	{

        if (scan) {

            scan = false;
            bt_start.setText("START");

        } else {

            scan = true;
            bt_start.setText("STOP");

            final SwingWorker worker = new SwingWorker() {

                public Object construct() {

                    String currentTagID = "";

                    if (rfid == null)
                        rfid = new RFID();

                    rfid.reset();

                    String version = rfid.getVersion();
                    System.out.println("VERSION:\t" + version);

                    while (scan) {

                        try {Thread.sleep(100);} catch (Exception e) {}

                        writePendingPages();

                        String select = rfid.select();

                        System.out.println("SELECT:\t" + select);

                        String errMsg = rfid.getErrorMsg(select);

                        if (errMsg != null) {

                            System.out.println("ERROR:\t" + errMsg);

                        } else {

                            // read tag info

                            String tagType = rfid.getTagType(select);
                            System.out.println("TYPE:\t" + tagType);
                            tf_tagType.setText(tagType);

                            String tagID = rfid.getTagID(select);
                            System.out.println("TAGID:\t" + tagID);
                            tf_tagID.setText(tagID);

                            if (!tagID.equals(currentTagID)) {

                                System.out.println("NEW TAG FOUND: READING MEMORY");
                                currentTagID = tagID;

                                // read tag memory

                                int adr = 0;
                                ArrayList memory = new ArrayList();

                                RFIDTableModel tableModel = new RFIDTableModel(memory, writeBuffer);
                                table_memory.setModel(tableModel);

                                while (errMsg == null) {

                                    writePendingPages();

                                    String hexAdr = Integer.toHexString(adr);

                                    // only two-digit adresses are possible

                                    if (hexAdr.equals("100"))
                                        break;

                                    if (hexAdr.length() == 1)
                                        hexAdr = "0" + hexAdr;

                                    String page = rfid.readPage(hexAdr);

                                    errMsg = rfid.getErrorMsg(page);

                                    if (errMsg != null) {
                                        System.out.println(hexAdr + ":\t" + errMsg);
                                    }   else {
                                        System.out.println(hexAdr + ":\t" + page);
                                        tableModel.append(page);
                                    }

                                    if (!scan) break;

                                    adr++;
                                }
                            }
                        }
                    }

                    return null;
                }
            };

            worker.start();
        }
	}
}
